# Importion of modules
import os
import sys
import pygame


# Initialize pygame
pygame.init()

class MagicPotionVessel( pygame.sprite.Sprite ):
	"""
	Magic Potion vessel class
	"""

	def __init__( self, image, top_left ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		# Keep track of the amount of liquid of each machine that flows into the vessel.
		self.yellow_liquid = 0
		self.purple_liquid = 0
		self.blue_liquid = 0
		self.green_liquid = 0

		self.run_off_open = False
		self.total_runoff = 0





	def update( self, liquid_machines, keyboard_events ):
		"""
		"""

		for event in keyboard_events:
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_r:
					self.run_off_open = True
				else:
					self.run_off_open = False
			if event.type == pygame.KEYUP:
				if event.key == pygame.K_r:
					self.run_off_open = False

		if self.run_off_open:
			self.open_runoff()
		else:
			self.total_runoff = 0

		
		for liquid_machine in liquid_machines:
			if liquid_machine.name_colour == "yellow":
				self.yellow_liquid += liquid_machine.current_liquid_output
			elif liquid_machine.name_colour == "purple":
				self.purple_liquid += liquid_machine.current_liquid_output
			elif liquid_machine.name_colour == "blue":
				self.blue_liquid += liquid_machine.current_liquid_output
			elif liquid_machine.name_colour == "green":
				self.green_liquid += liquid_machine.current_liquid_output
			else:
				pass


	def open_runoff( self ):
		"""
		Causes liquid to run off.
		"""

		self.total_runoff += 1
		if self.yellow_liquid > 0:
			if self.yellow_liquid < self.total_runoff:
				self.yellow_liquid = 0
			else:
				self.yellow_liquid -= self.total_runoff

		if self.purple_liquid > 0:
			if self.purple_liquid < self.total_runoff:
				self.purple_liquid = 0
			else:
				self.purple_liquid -= self.total_runoff

		if self.blue_liquid > 0:
			if self.blue_liquid < self.total_runoff:
				self.blue_liquid = 0
			else:
				self.blue_liquid -= self.total_runoff

		if self.green_liquid > 0:
			if self.green_liquid < self.total_runoff:
				self.green_liquid = 0
			else:
				self.green_liquid -= self.total_runoff
